/*
 * Gyatzee: Gnomified Yahtzee game.
 * (C) 1998 the Free Software Foundation
 *
 * File:   cyahtzee.c
 *
 * Author: Scott Heavner
 *
 *   Curses based yahtzee routines.  --- VERY BROKEN !!!!!!!!!!!!!!!!!!!
 *
 *   Variables are exported in yahtzee.h
 *
 *   This program is based on based on orest zborowski's curses based
 *   yahtze (c)1992.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include "yahtzee.h"

int roll_dice(int num)
{
	int val;
	int i;
	int j;

	if (num < 1 || num > 5)
		abort("Bad dice loc passed");

	for (j = 0; j < 1; ++j)
	{
		val = roll_die();

		for (i = 0; i < 4; ++i)
		{
			move(((num - 1) * 4) + i, 0);

			if (i == 2)
				printw("%d", num);
			else
				addch(' ');
			addstr(dice[val - 1][i]);
		}

		if (num == 5)		/* put the last +---+ tail */
		{
			mvaddch(20, 0, ' ');
			addstr(dice[0][0]);
		}
	}
	refresh();

	return (val);
}

void play_dice(int player)
{
	int i;
	char buf[50];
	char *cp;
	char *num;
	int done;
	int field;
	int dummy;
	int numroll;

	say("Rolling for %s", players[player].name);

	for (i = 1; i < 6; ++i)
		DiceValues[i - 1].val = roll_dice(i);

	for (numroll = 1; numroll < NUM_ROLLS; ++numroll)
	{
		query(player, 1, "What dice to roll again (<RETURN> for none)? ",
                      buf, sizeof(buf));

		cp = buf;
#if 0
		if (*cp == '\0')
			break;

		done = 0;

		for (;;)
		{
			num = cp;
			while (*cp != '\0' && *cp != ',' && *cp != '\t' && *cp != ' ')
				++cp;
			if (*cp == '\0')
				done = 1;
			*cp++ = '\0';
			i = atoi(num);
			if (i >= 1 && i <= 5)
				DiceValues[i - 1].val = roll_dice(i);
			if (done)
				break;
		}
#else
		if (*cp == '\0')	/* User pressed return */
			break;

		done = 0;
		while (*cp != '\0') {
			if (*cp >= '1' && *cp <= '5') {
				DiceValues[*cp - '1'].val = roll_dice(*cp-'0');
				done = 1;
			}
			++cp;
		}
		if (!done)		/* User typed bogus input, repeat roll */
			numroll--;
#endif
	}
}



void query_score(int player)
{
	char buf[50];
	int field;
	int dummy;

	query(player, 2, "Where do you want to put that? ", buf, sizeof(buf));
	done = 0;

	for (;;)
	{
		if (buf[0] < 'a' || buf[0] > 'm')
		{
			query(player, 2, "No good! Where do you want to put that? ",
                              buf, sizeof(buf));
			continue;
		}

		field = buf[0] - 'a';

                dummy = play_score(player, field);

                if (dummy==SLOT_USED) {
                        query(player, 2, "Already used! Where do you want to put that? ",
                              buf, sizeof(buf));
                        
                        continue;
                }

                break;
        }
}


main(int argc, char **argv)
{
	char num[10];
	int i;
	int num_computers;
	short onlyshowscores = 0;

	yahtzee_init();

	parse_options(argc, argv);

	setup_screen();

	set_signal_traps();

	if (!onlyshowscores)
	{
		setup_board();

		play();

		update_scorefile();
	}

	yend();
	show_top_scores();

	exit(0);
}
